﻿using System;
using System.Threading;
using Serilog;
using StockBot.Code.Util;
using StockBot.Code.Xing;
using XingAPINet;

namespace StockBot.Code.Action
{
    public class TradeBuy
    {
        public static void Buy(StockInst stockInst, string account, string hName, string shCode, long budget)
        {
            Log.Information($"Call Buy. Name:{hName}, curr budget: {budget}");
            Thread.Sleep(1000);// #1초

            var outBlock = XQt1101.Get(shCode);

            var bidHo1 = outBlock.bidho1;
            var bidRem1 = outBlock.bidrem1;
            var offerHo1 = outBlock.offerho1;
            var offerRem1 = outBlock.offerrem1;
            var offer = outBlock.offer;
            var bid = outBlock.bid;
            

            var currValue = XQt1102.Get(shCode).price;

            using (XQCSPAT00600 query = new XQCSPAT00600())//#매수
            {
                var input = new XQCSPAT00600InBlock1
                {
                    AcntNo = account,
                    InptPwd = "0000",
                    IsuNo = StockCodeFilter.GetExpCode(shCode),
                    OrdQty = 1,
                    OrdPrc = StockCodeFilter.GetCurrentPrice(shCode),
                    BnsTpCode = Keywords.BnsTpCode.매수,
                    OrdprcPtnCode = Keywords.OrdprcPtnCode.지정가,
                    MgntrnCode = Keywords.MgntrnCode.보통,
                    LoanDt = null,
                    OrdCndiTpCode = Keywords.OrdCndiTpCode.없음
                };

                input.Dump(Console.Out);
                if (!input.VerifyData())
                {
                    Log.Error("???");
                }

                query.SetBlock(input);

                var err = query.Request(false);
                if (err < 0)
                {
                    Log.Error($"Failed query: {query.QueryResult.Message}");
                    //Log.Error(query.QueryResult);
                    return;
                }

                var msg = query.QueryResult.Message;
                Log.Error($" 입력값이 맞는것 같은데 오류가 납니다. {msg}");

                var block1 = query.GetBlock1();
                if (!block1.IsValidData)
                {
                    Log.Error("00600 Failed 1");
                }
                //block1.Dump(Console.Out);

                var block2 = query.GetBlock2();
                if (!block2.IsValidData)
                {
                    Log.Error("00600 Failed 2");
                }

                Log.Information($"[Buy] OrderNo: {block2.OrdNo}");
                //block2.Dump(Console.Out, DumpOutputType.Inline);
            }
            Thread.Sleep(100);
        }
    }
}