﻿using System.Collections.Generic;
using Serilog;
using XingAPINet;

namespace StockBot.Code.Xing
{
    public class StockInst
    {
        public IReadOnlyDictionary<string, string> StockIds { get; private set; }//shcode, name

        private XingClient _xingClient;

        public bool Init(LoginInfo loginInfo, bool useDemoServer)
        {
            Log.Information("--start-- stock bot init");
            
            var serverName = useDemoServer ? "데모서버" : "실제서버";
            Log.Warning($"==== {serverName} 사용 ====");

            _xingClient = new XingClient(useDemoServer);
            if (_xingClient.ConnectWithLogin(loginInfo) == false) // 서버 접속
            {
                Log.Information(_xingClient.ErrorMessage);
                return false;
            }

            return true;
        }
    }
}
