﻿using System;
using Serilog;
using Serilog.Events;
using StockBot.Code.Action;
using StockBot.Code.Xing;
using XingAPINet;

namespace StockBot
{
    class Program
    {
        private const int MEGA_BYTE = 1024 * 1024;

        static void Main(string[] args)
        {
            Log.Logger = new LoggerConfiguration()
                .WriteTo
                .File($".\\Log\\{"bot"}.txt", LogEventLevel.Information,
                    "{Message:lj}{NewLine}{Exception}",
                    null, MEGA_BYTE * 5, null, true, false, TimeSpan.Zero)
                .WriteTo.Console()
                .CreateLogger();

            ////////////////////////////////////////////////////////////////////////////////////////////////////
            
            // 아이디, 암호, 계좌를 넣어 주십시오.

            var loginInfo = LoginInfo.FromPlainText("아이디", "암호", "");

            var stockInst = new StockInst();
            if (!stockInst.Init(loginInfo, true))
            {
                Log.Error("init login fail");
                return;
            }

            TradeBuy.Buy(stockInst, "계좌", "이베스트", "078020", 10000);

            Log.Information("Process End");
        }
    }
}